'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Rotation = function (_Component) {
  _inherits(Rotation, _Component);

  function Rotation() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Rotation);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Rotation.__proto__ || Object.getPrototypeOf(Rotation)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      current: 0
    }, _this.handleWheel = function (event) {
      event.preventDefault();
      var deltaY = event.deltaY;
      var reverse = _this.props.reverse;
      var current = _this.state.current;

      var delta = deltaY === 0 ? 0 : deltaY / Math.abs(deltaY);
      _this.stop();
      _this.setCurrentFrame(reverse ? current - delta : current + delta);
    }, _this.handleTouchStart = function (event) {
      event.preventDefault();
      _this.pointerPosition = _this.calculatePointerPosition(event);
      _this.startFrame = _this.state.current;
      _this.stop();
    }, _this.handleTouchMove = function (event) {
      var _this$props = _this.props,
          vertical = _this$props.vertical,
          children = _this$props.children,
          reverse = _this$props.reverse;

      event.preventDefault();
      if (typeof _this.pointerPosition !== 'number') return;

      var _findDOMNode = (0, _reactDom.findDOMNode)(_this),
          offsetWidth = _findDOMNode.offsetWidth,
          offsetHeight = _findDOMNode.offsetHeight;

      var pointer = _this.calculatePointerPosition(event);
      var max = vertical ? offsetHeight : offsetWidth;
      var offset = pointer - _this.pointerPosition;
      var delta = Math.floor(offset / max * children.length);
      _this.setCurrentFrame(reverse ? _this.startFrame - delta : _this.startFrame + delta);
    }, _this.handleTouchEnd = function (event) {
      event.preventDefault();
      _this.pointerPosition = null;
      _this.startFrame = null;
    }, _this.handleKey = function (event) {
      if (!event.target.tagName.match('TEXTAREA|INPUT|SELECT')) {
        var current = _this.state.current;
        var _this$props2 = _this.props,
            vertical = _this$props2.vertical,
            reverse = _this$props2.reverse;

        var prevKey = vertical ? 38 : 37;
        var nextKey = vertical ? 40 : 39;
        _this.stop();

        if (event.keyCode === prevKey) {
          _this.setCurrentFrame(reverse ? current + 1 : current - 1);
        } else if (event.keyCode === nextKey) {
          _this.setCurrentFrame(reverse ? current - 1 : current + 1);
        }
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Rotation, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var el = (0, _reactDom.findDOMNode)(this);
      if (this.props.scroll) el.addEventListener('wheel', this.handleWheel, false);
      el.addEventListener('touchstart', this.handleTouchStart, false);
      el.addEventListener('touchmove', this.handleTouchMove, false);
      el.addEventListener('touchend', this.handleTouchEnd, false);
      el.addEventListener('mousedown', this.handleTouchStart, false);
      el.addEventListener('mousemove', this.handleTouchMove, false);
      document.addEventListener('mouseup', this.handleTouchEnd, false);
      if (this.props.autoPlay) this.nextFrame();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref2) {
      var autoPlay = _ref2.autoPlay;

      if (autoPlay !== this.props.autoPlay) {
        if (autoPlay) {
          this.nextFrame();
        } else {
          this.stop();
        }
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var el = (0, _reactDom.findDOMNode)(this);
      if (this.props.scroll) el.removeEventListener('wheel', this.handleWheel, false);
      el.removeEventListener('touchstart', this.handleTouchStart, false);
      el.removeEventListener('touchmove', this.handleTouchMove, false);
      el.removeEventListener('touchend', this.handleTouchEnd, false);
      el.removeEventListener('mousedown', this.handleTouchStart, false);
      el.removeEventListener('mousemove', this.handleTouchMove, false);
      document.removeEventListener('mouseup', this.handleTouchEnd, false);
      this.stop();
    }
  }, {
    key: 'setCurrentFrame',
    value: function setCurrentFrame(frame) {
      var _props = this.props,
          cycle = _props.cycle,
          children = _props.children,
          onChange = _props.onChange;

      var length = children.length;
      var current = frame;
      if (current < 0) current = cycle ? current + length : 0;
      if (current > length - 1) current = cycle ? current - length : length - 1;

      if (current !== this.state.current) {
        this.setState({ current: current });
        if (typeof onChange === 'function') onChange(current);
      } else if (this.props.autoPlay) {
        this.stop();
      }
    }
  }, {
    key: 'nextFrame',
    value: function nextFrame() {
      var _this2 = this;

      var current = this.state.current;
      var reverse = this.props.reverse;

      this.setCurrentFrame(reverse ? current - 1 : current + 1);

      this.nextTimeout = setTimeout(function () {
        _this2.nextFrame();
      }, 75);
    }
  }, {
    key: 'stop',
    value: function stop() {
      clearTimeout(this.nextTimeout);
    }
  }, {
    key: 'calculatePointerPosition',
    value: function calculatePointerPosition(event) {
      var touch = event.type.indexOf('touch') === 0 ? event.changedTouches[0] : event;
      var clientX = touch.clientX,
          clientY = touch.clientY;

      var _findDOMNode2 = (0, _reactDom.findDOMNode)(this),
          offsetTop = _findDOMNode2.offsetTop,
          offsetLeft = _findDOMNode2.offsetLeft;

      return this.props.vertical ? clientY - offsetTop : clientX - offsetLeft;
    }
  }, {
    key: 'render',
    value: function render() {
      var current = this.state.current;
      var _props2 = this.props,
          children = _props2.children,
          className = _props2.className,
          tabIndex = _props2.tabIndex;


      return _react2.default.createElement(
        'div',
        {
          tabIndex: tabIndex,
          onKeyDown: tabIndex >= 0 ? this.handleKey : null,
          className: className,
          style: { position: 'relative' } },
        _react.Children.map(children, function (child, i) {
          return (0, _react.cloneElement)(child, {
            style: {
              width: '100%',
              display: current === i ? 'block' : 'none'
            }
          });
        })
      );
    }
  }]);

  return Rotation;
}(_react.Component);

Rotation.propTypes = {
  className: _propTypes2.default.string,
  cycle: _propTypes2.default.bool,
  scroll: _propTypes2.default.bool,
  vertical: _propTypes2.default.bool,
  reverse: _propTypes2.default.bool,
  autoPlay: _propTypes2.default.bool,
  onChange: _propTypes2.default.func,
  children: _propTypes2.default.arrayOf(_propTypes2.default.element).isRequired,
  tabIndex: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number])
};
Rotation.defaultProps = {
  cycle: false,
  scroll: true,
  vertical: false,
  tabIndex: 0,
  autoPlay: false
};
exports.default = Rotation;
